      subroutine argn_of_symbol (sym,argn,nia,quc)
c UTIDE * Return astr.arg.no of symbol
c >
c sym         - char**  - 4 signif.chars, Darwin tide symbol, 
c                         or 7++ signif.chars, Doodson symbol, input
c argn(0:nia) - int*2   - nia=7 or 9 for arguments without/with Venus+Jupiter
c                         returned: Argument numbers
c                         argn(0) = spherical harmonic degree
c                         argn(1) = spherical harmonic order ~ cycles/day
c                         argn(2) = multiplies s  
c                         argn(6) = multiplies p_s
c                         etc
c quc         - logical - ignore character case upper/lower
c
c The inverse function is
c     symbol_of_argn (argn,nia,sym)
c Here, nia may be used to limit the comparison to the first nia argument
c numbers. If (nia=9 and (argn(7)=/=0 or argn(8)=/=0)) no symbol will be
c returned (there are no Darwin symbols for Venus/Jupiter terms).
c The phase factors (old: argn(7); new: argn(9) are always ignored.
c
c In order to extend the table: PARAMETER (NDIM = length)
c Use all lower case characters to code greek ('phi1')
c long-period: Msqm Mtm etc.
c_
      parameter (ndim= 57)
      integer*2 arg(0:7,ndim), argn(0:nia)
      character sy*4, sym*(*), symb*4, symt*4, chr*1
      dimension sy(ndim)
      logical quc,qf,q9
      data ((arg(i,j),i=0,7),sy(j),j=1,ndim)/
     &   2, 2,-3, 0, 3, 0, 0, 0,'2N3 '
     &,  2, 2,-3, 2, 1, 0, 0, 0,'eps2'
     &,  2, 2,-2, 0, 2, 0, 0, 0,'2N2 '
     &,  2, 2,-2, 2, 0, 0, 0, 0,'mu2 '
     &,  2, 2,-1, 0, 1, 0, 0, 0,'N2  '
     &,  2, 2,-1, 2,-1, 0, 0, 0,'nu2 '
     &,  2, 2, 0,-2, 2, 0, 0, 2,'gam2'
     &,  2, 2, 0,-1, 0, 0, 1, 2,'alf2'
     &,  2, 2, 0, 0, 0, 0, 0, 0,'M2  '
     &,  2, 2, 0, 1, 0, 0,-1, 0,'bet2'
     &,  2, 2, 1,-2, 1, 0, 0, 2,'lmb2'
     &,  2, 2, 1, 0,-1, 0, 0, 2,'L2  '
     &,  2, 2, 2,-4, 0, 0, 2, 0,'2T2 '
     &,  2, 2, 2,-3, 0, 0, 1, 0,'T2  '
     &,  2, 2, 2,-2, 0, 0, 0, 0,'S2  '
     &,  2, 2, 2,-1, 0, 0,-1, 2,'R2  '
     &,  2, 2, 2, 0, 0, 0, 0, 0,'K2  '
     &,  2, 2, 3,-2, 1, 0, 0, 0,'xi2 '
     &,  2, 2, 3, 0,-1, 0, 0, 0,'eta2'
     &,  2, 1,-3, 0, 2, 0, 0,-1,'2Q1 '
     &,  2, 1,-3, 2, 0, 0, 0,-1,'sig1'
     &,  2, 1,-2, 0, 1, 0, 0,-1,'Q1  '
     &,  4, 1,-2, 0, 1, 0, 0,-1,'Q14 '
     &,  2, 1,-2, 2,-1, 0, 0,-1,'rho1'
     &,  2, 1,-1, 0, 0, 0, 0,-1,'O1  '
     &,  4, 1,-1, 0, 0, 0, 0,-1,'O14 '
     &,  2, 1,-1, 2, 0, 0, 0, 1,'tau1'
     &,  2, 1, 0, 2,-1, 0, 0, 1,'chi1'
     &,  2, 1, 1,-3, 0, 0, 1,-1,'PI1 '
     &,  2, 1, 1,-2, 0, 0, 0,-1,'P1  '
     &,  2, 1, 1,-1, 0, 0, 1, 1,'S1  '
     &,  2, 1, 1, 0, 0, 0, 0, 1,'K1  '
     &,  4, 1, 1, 0, 0, 0, 0, 1,'K14 '
     &,  2, 1, 1, 1, 0, 0,-1, 1,'psi1'
     &,  2, 1, 1, 2, 0, 0, 0, 1,'phi1'
     &,  2, 1, 2,-2, 1, 0, 0, 1,'the1'
     &,  2, 1, 2, 0,-1, 0, 0, 1,'J1  '
     &,  2, 1, 3,-2, 0, 0, 0, 1,'SO1 '
     &,  2, 1, 3, 0, 0, 0, 0, 1,'oo1 '
     &,  2, 1, 4, 0,-1, 0, 0, 1,'v1  '
     &,  2, 0, 0, 0, 0, 0, 0, 0,'M0S0'
     &,  2, 0, 0, 1, 0, 0,-1, 0,'Sa  '
     &,  2, 0, 0, 1, 0, 0,-1, 2,'Sa  '
     &,  2, 0, 0, 2, 0, 0, 0, 0,'Ssa '
     &,  2, 0, 0, 3, 0, 0,-1, 0,'Sta '
     &,  2, 0, 1,-2, 1, 0, 0, 0,'Msm '
     &,  2, 0, 1, 0,-1, 0, 0, 0,'Mm  '
     &,  2, 0, 2,-2, 0, 0, 0, 0,'Msf '
     &,  2, 0, 2, 0, 0, 0, 0, 0,'Mf  '
     &,  2, 0, 3,-2, 1, 0, 0, 0,'Mstm'
     &,  2, 0, 3, 0,-1, 0, 0, 0,'Mtm '
     &,  2, 0, 4,-2, 0, 0, 0, 0,'Msqm'
     &,  3, 3,-3, 0, 3, 0, 0, 2,'3N3 '
     &,  3, 3, 0,-1, 0, 0, 1, 0,'alf3'
     &,  3, 3, 0, 0, 0, 0, 0, 2,'M3  '
     &,  3, 3, 0, 1, 0, 0,-1, 2,'bet3'
     &,  3, 3, 3, 0,-1, 0, 0, 2,'eta3'/
      lsy=len(sym)
      kd=index(sym,'.')
      if (lsy.gt.4.and.kd.gt.0) then ! it's a Doodson symbol
         argn(0)=2
         argn(1)=index(' 123',sym(kd-3:kd-3))-1
         if (argn(1).eq.3) argn(0)=3
         k=kd-3
         do i=2,6
121      k=k+1
         chr=sym(k:k)
         if (chr.eq.'.') goto 121
         argn(i)=index('0123456789XE',chr)-6
         enddo
         if (nia.eq.9) then
            argn(7)=0
            argn(8)=0
         endif
         nt = nr_of_tide_argn (argn,0,nia-1,nia)
         return
      else
         

      isb=index_1_nonblank(sym)
      ls=min0(isb+3,lsy)
      if (quc) then
         call ucase (sym(isb:ls),symb)
      else
         symb=sym(isb:ls)
      endif
      symb=symb(:ls-isb+1)//'    '

      do 101 i=1,ndim
      if (quc) then
         call ucase(sy(i),symt)
      else
         symt=sy(i)
      endif
      
      if (symt.eq.symb) then
         do 102 k=0,6
102      argn(k)=arg(k,i)
         if (nia.gt.7) then
            argn(7)=0
            argn(8)=0
            argn(9)=arg(7,i)
         else
            argn(7)=arg(7,i)
         endif
         return
      endif
101   continue
      print '(3a,i3)',' <ArgOSy>E> Unknown symbol "',symb,'"',ls-isb+1
      argn(0)=-9
      return
      endif

      entry symbol_of_argn (argn,nia,sym)
c UTIDE * return symbol of astr.arg.no
c
      kmax=nia
      if (kmax.lt.0.or.kmax.ge.7) kmax=6
      q9=nia.ge.8
      
      do 201 i=1,ndim
      qf=.true.
      do 202 k=0,kmax
      qf=qf.and.argn(k).eq.arg(k,i)
      if (.not.qf) goto 201
202   continue
      if (q9) qf=qf.and.argn(8).eq.0
     &             .and.argn(7).eq.0
      if (.not.qf) goto 201
      sym=sy(i)
      return
201   continue
      sym='n.n.'
      return
      end

