      double precision function dgcdis (x1,y1,x2,y2,vrad)
c
c computes distance along great circle between (x1,y1) and (x2,y2)
c vrad (input) contols metric units:
c vrad = 1.d0   - locations and returned function value are in degrees.
c vrad = pi/180 - locations ... in radians.
c
      implicit real*8 (a-h,o-z)
      common /mpar/ pi,rad
      save
      if (dabs(pi-3.d0).gt..2d0) then
         rad=datan(1.d0)/45.d0
         pi=180*rad
      endif
      urad=rad/vrad
      syh=dsin((y2-y1)*urad/2.d0)
      sxh=dsin((x2-x1)*urad/2.d0)
      ccc=dcos(y1*urad)*dcos(y2*urad)
      sqh=syh*syh+sxh*sxh*ccc
      dgcdis=2*dasin(dsqrt(sqh))/urad
      return
      end

      real function gcdis (x1,y1,x2,y2,rad)
      real*8 dgcdis
      gcdis=dgcdis(dble(x1),dble(y1),dble(x2),dble(y2),dble(rad))
      return
      end

C:Provides  real function gcdis F=gcdis.f
C:Provides  double precision function dgcdis F=gcdis.f
