      subroutine get_harpos (iun,opt,site,xlon,ylat,alt,z,oth,mz
c OL BLQ * Get an OL HARPOS record
     &,                      cf,cc,*)
c
c opt RS and site=' ': reset, get harmonics and first comments, return
c opt not S and not C: get next site
c opt S, site not ' ': get that site
c opt C: find closest site.
c Set distance criterion by call get_ol_locacc (distance_degrees)
c
c z(mz,3) - complex*8 - loading coefficients returned
c oth(mz) - char*8    - associated tide symbols
c
c If you set the OLTIDES(N_OLTIDES) array in COMMON /CCOLRE/ before calling
c this routine, it will generate a hash table and return MZ tides through
c the call list and simultaneously return N_OLTIDES coefficients through
c COMMON /CZOLRE/ ZVC(N_OLTIDES,3)
c
c That common block will be retrieved by subsequent CALL GET_OL_REC (IUN,...)
c with IUN set less than zero.
c
      implicit logical (q)
      include 'colrec.fca'
      character ts*8, td*4, str*80, sitf*8, sito*8, sitr*8
      complex*8 z(mz,3), zv, polar
      real*8    xf,yf,zf
      integer   koth(100)
      
      character    site*(*), opt*(*)
      character*8  oth(mz), otf
      character*77 cf,cc,cft,cct
      character    locstr*11, locopt*8

      real*8 xc,yc,zc
      common /csitrc/ xc,yc,zc

      complex*8 zvc(n_oltides,3)
      common /czolre/ zvc

      save

      data koth/100*-1/,noth/0/,sito/' '/,q1/.true./, locopt/' '/
     &,    qf,qc/2*.false./, nat/0/, qco,qso/2*.false./, iip/0/
      
      do i=1,n_oltides
         print *,i,' ',oltides(i)
      enddo
      olnrw=3
      qdbg=qor_index(opt,'dD',i)
      if (qdbg) print *,'<gharpo>d> entered, q1=',q1,' opt=',opt
      if (qdbg) print *,'<gharpo>d> site ',site,' sito ',sito
c
c (0) reset if R e opt
      if (qor_index(opt,'Rr',i)) then
         q1=.true.
         nat=0
         sito=' '
         do i=1,100
            koth(i)=-1
         enddo
         do i=1,mz
            oth(i)=' '
         enddo
         qc=.false.
         qf=.false.
         cc=' '
         cf=' '
         iip=0
         if (qdbg) print *,'Init done'
      endif
      qco=qor_index(opt,'Cc',i)
      qcs=qor_index(opt,'Ss',i)
      qdbg=qor_index(opt,'Dd',i)
      dismin=999.e0
      
c
c (0) find comments
      if (.not.(qf.and.qc)) rewind (iun)
 10   if (qf.and.qc) goto 91
      read (iun,'(a)',end=91) str
      if (str(1:3).eq.'#F ') then
         cf=str(4:)
         if (qdbg) print *,'FComment ',cf
         qf=.true.
      elseif (str(1:3).eq.'#C ') then
         cc=str(4:)
         if (qdbg) print *,'CComment ',cc
         qc=.true.
      endif
      goto 10
c
 91   rewind (iun)
      iin=0
      if (qdbg) print *,'Start site search'
      q1=.true.
c
c
c Go thru file, if H-records, store symbols and reserve table space
c if S-record, then 3 alts: 
c  1 go through whole table and find closest place to given xlon xlat
c  2 find the site 
c  3 take next site
c
c    When do you know a site is complete?
c    when all reserved columns are filled
c 
c 
      locopt=' '
      if (sito(1:1).ne.' '.and.
     &    .not.(qco.or.qso)) then
         do i=1,iip
         read (iun,'(a)',end=92) str
         iin=iin+1
         enddo 
         read (iun,'(a)',end=92) str
         iin=iin+1
         if (qdbg) print *,'POS after ->',str
      endif
      
      
 11   read (iun,'(a)',end=92) str
      iin=iin+1

      if (str(1:3).eq.'#F ') then
         cf=str(4:)
         qf=.true.
      endif
      if (str(1:3).eq.'#C ') then
         cc=str(4:)
         qc=.true.
      endif

      if (str(1:2).eq.'S ') then
         sitf=str(4:11)
         call delete_in_string (sitf,' ',1,0)
cc         if (qdbg) print *,'consider ->',sitf,'<-'
         read (str,2101) xf,yf,zf,slon,slat,salt
         if (qco) then
            dis=gcdis(slon,slat,xlon,xlat,1.)
            if (dis.gt.dismin) then
               goto 11
            else
               dismin=dis
               slonf=slon
               slatf=slat
               altf=salt
               sito=sitf
               if (qdbg) print *,'OPT C: dis=',dis,' at ',sito
            endif
            k=0
            q1=.false.
         elseif (qso) then
            sito=site
            slonf=slon
            slatf=slat
            altf=salt
            if (qdbg) print *,'OPT S: accept ',sito
            q1=.false.
         elseif (q1) then
            iip=iin
            sito=sitf
            slonf=slon
            slatf=slat
            altf=salt
            q1=.false.
            if (qdbg) print *,'Accept next site ',sitf
         endif
         if (sitf.ne.sito) goto 11
         sito=sitf
      endif

      if (str(1:2).eq.'H ') then
         ts=str(4:11)
         if (index_l_nonblank(ts).gt.4) then
            call doodson_to_darwin (ts,td)
         else
            call ucase (ts,td)
         endif
         do i=1,nat
            if (oth(i).eq.td) goto 101
         enddo
         nat=nat+1
         if (nat.le.mz) then
            oth(nat)=ts
            do i=1,n_oltides
               ls=index_l_nonblank(oltides(i))
               if (oltides(i)(:ls).eq.td(:ls)) then
                  koth(nat)=i
      if (qdbg) print *,'HAR:',nat,i,' ',ts,td,' ',oltides(i)
               endif
            enddo
         endif
 101     continue
      endif
         
      if (.not.q1.and.str(1:2).eq.'D ') then         
         sitr=str(14:21)
         call delete_in_string (sitr,' ',1,0)
         if (sitr.eq.sitf) then
            k=k+1
            if (k.le.mz) then
               read (str,2102) (z(k,j),j=1,3)
               kk=koth(k)
               if (kk.gt.0.and.kk.le.nat) then
                  do j=1,3
                     zv=polar(z(k,j),180.)
                     olamp(kk,j)=real(zv)
                     olpha(kk,j)=aimag(zv)
                     zvc(kk,j)=z(k,j)
                  enddo
                  if (qdbg) print *,'<gharpo>d> store ',sitf,' ',kk,k
     &                             ,' ',oth(k)
               else
                  print *,'Bad kk',kk,nat,' at ',sitr,' ',sitf
               endif
            else
               print *,'too big',k,mz,' at ',sitr,' ',sitf
            endif
         else
            if (qdbg) print *,'NONMATCH ->',sitr,'<->',sitf,'<-'
         endif     
      endif
      goto 11
 92   if (q1) return 1
      site=sito
      ylat=slatf
      xlon=slonf
      alt=altf
      xc=xf
      yc=yf
      zc=zf
      return

 2101 format (t13,3f14.4,t56,2f9.4,f6.1)
 2102 format (t24,f9.0,t53,f9.0,t33,f9.0,t62,f9.0,t42,f9.0,t71,f9.0)
      end
C:Provides  subroutine get_harpos F=getharpos.f
