      program centre_of_mass ! correction of ocean loading table
      complex   zv(3), zc(3,11), z(11,3), zd(20,3), polar
      character site*8, monu*16, sitel*48, cf*77, cc*77, cfo*77
     &,         fmt23*64, opt*8
     &,         ans*1, tide*4, blq_site_fmt*48, buff*48
     &,         oth*8, tides*4
      dimension tides(11),oth(20)
      logical   qop
      common /colrec/ amp(11,3), pha(11,3)
      character cols*80
      common /ccposh/ cols
      
      logical qhf,qhp,qbq
      common /cposh/ qhf,qhp,qbq
      
      data zc/33*(0.0,0.0)/
      data tides/'M2  ','S2  ','N2  ','K2  '
     &,          'K1  ','O1  ','P1  ','Q1  '
     &,          'MF  ','MM  ','SSA '/
      data blq_site_fmt/'(2x,a8,a6)'/, opt/' '/
c
c The cmc-data can be obtained with the CMC-option in olfg.f.
c The file is referred to in the comments below as cmc.rsl.
c Some manual update is required before cmc.rsl can be used by olcmc.f:
c (1) add one line of comment etc. at the top
c (2) add one line with the format to be used; e.g. '(a2,t26,3(2x,2f12.4))'
c
c Files to open:
c 20 - header.blq
c 21 - input.blq
c 23 - cmc.rsl
c 31 - output.blq
c
c If file 21 is not opened, the output will contain a blq version of
c the cmc data. 
c
      rad=atan(1.0)/45.
      call open_ins (4,'olcmc.ins')
      call openf (4)
      
      iun=4
      read (4,'(a)',end=99,iostat=ier) buff
      if (buff(1:1).ne.' ') blq_site_fmt=buff
      call put_ol_sitefmt (blq_site_fmt)

      iun=23
      read (23,'(a)',end=99,iostat=ier) fmt23
      i=index_1_nonblank(fmt23)
      if (fmt23(i:i).ne.'(') read (23,'(a)') fmt23
      i=index_1_nonblank(fmt23)
      if (fmt23(i:i).ne.'(') then
         print *,'<Main-->T> Need a format in first or second line'
     &,' on unit 23.'
         stop 'BAD FILE 23'
      endif

      mnt=11
      do 102 j=1,11
         read (23,fmt23,end=118) tide,(zv(i),i=1,3)
         call ucase(tide,tide)
         lt=index(tide//' ',' ')-1
         do 103 k=1,11
            if (index(tides(k),tide(:lt)).gt.0) then
               do i=1,3
                  zc(i,k)=zv(i)
               enddo
               mnt=k
            endif
 103     continue      
 102  continue
      
 118  print '(a)',' cmc coeff ready.'
      do j=1,mnt
         print '(a4,3(2x,1p,e12.4,0p,f8.0))'
     &,         tides(j),(polar(zc(i,j),180.),i=1,3)
      enddo
      do j=1,mnt
         print '(a4,3(2x,2f8.4))',tides(j),(zc(i,j)*1.e3,i=1,3)
      enddo

      inquire (unit=20,opened=qop)
      if (qop) then
         iuh=20
      else
         iuh=-1
      endif
      call enter_ol_blq (iuh,tides,mcol,nrow)
      if (mcol.le.0) call default_ol_blq (tides,mcol,nrow)
      print *,'TIDES:',tides

      inquire (unit=21,opened=qop)
      iut=21
      
      call pos_header_c (iut,iuh,31,2)
      print '(a,i2)',' <Main-->>> Table header ready, iut=',iut
      print '(2a)',' <Main-->>> File cols(1..2): ',cols(1:8)
C      print '(a,$)',' Press ENTER'
C      read '(a)', ans

      if (qhp.and.iuh.gt.0) then
         rewind (iuh)
         site=' '
         call get_harpos (iut,'RSd',site,xlon,ylat,salt
     &,                   zd,oth,20,cf,cc,*19)
 19      continue
         print *,'First HARPOS record after header'
      endif

      if (qop) then
 1       iut=21
         if (qhp) then
            site=' '
            call get_harpos (iut,'d',site,xlon,ylat,salt
     &,                      zd,oth,20,cf,cc,*9)
            opt='H'
            if (cf.ne.cfo) opt='HC'
            iut=-1
         endif
         call get_ol_rec (iut,' ',site,monu,xlon,ylat,salt,z
     &,                   sitel,cf,cc,*9)
         
         print *,'Do the job for ',site,xlon,ylat,salt
         x=xlon*rad
         y=ylat*rad
         sx=sin(x)
         cx=cos(x)
         sy=sin(y)
         cy=cos(y)
         kount=0
         
         do 101 i=1,mnt
            az=cabs(z(i,1))+cabs(z(i,2))+cabs(z(i,3))
            if (az.gt.1.e-10) then
               kount=kount+1
               z(i,1)=z(i,1)+zc(1,i)*sy+(zc(2,i)*cx+zc(3,i)*sx)*cy
               z(i,2)=z(i,2)-zc(2,i)*sx+zc(3,i)*cx
               z(i,3)=z(i,3)+zc(1,i)*cy-(zc(2,i)*cx+zc(3,i)*sx)*sy
            endif
 101     continue
         print *,'Hello'
         call replace_in_string 
     &        (cc,'Computed by ','Computed by OLCMC/',1,0)
         print *,'Hello again '//cc
         call put_ol_rec (31,opt,site,monu,xlon,ylat,salt,z
     &,                   sitel,cf,cc)
         cfo=cf
         print '(i3,i4,2a)', mnt,kount,' tides for site ',site
         goto 1
         
 9       call end_ol_rec (31)
      else
         sx=0.
         cx=1.
         sy=0.
         cy=1.
         site='COM YZ0'
         monu='  0001'
         xlon=0.
         ylat=0.
         salt=0.
         sitel='Centre-of-mass YZ'//monu
c         write (sitel(30:),'(a,2f10.4)') ' lon/lat: ',xlon,ylat
         cf='OLCMC transformed'
         cc='Computed by H.G.Scherneck Onsala Space Observatory, '
         lc=index_l_nonblank(cc)+2
         call date(cc(lc:lc+8))

         do 201 i=1,mnt
         z(i,1)=zc(1,i)*sy+(zc(2,i)*cx+zc(3,i)*sx)*cy
         z(i,2)=-zc(2,i)*sx+zc(3,i)*cx
         z(i,3)=zc(1,i)*cy-(zc(2,i)*cx+zc(3,i)*sx)*sy
201      continue

         call put_ol_rec (31,opt,site,monu,xlon,ylat,salt,z
     &,                   sitel,cf,cc)

         sx=1.
         cx=0.
         sy=0.
         cy=1.
         site='COM XZ0'
         monu='  0001'
         xlon=90.
         ylat=0.
         salt=0.
         sitel='Centre-of-mass XZ'//monu
c         write (sitel(30:),'(a,2f10.4)') ' lon/lat: ',xlon,ylat
         cf='OLM621 result'
         cc='Computed by H.G.Scherneck Onsala Space Observatory, '
         lc=index_l_nonblank(cc)+2
         call date(cc(lc:lc+8))

         do 202 i=1,mnt
         z(i,1)=zc(1,i)*sy+(zc(2,i)*cx+zc(3,i)*sx)*cy
c         z(i,2)=zc(2,i)*sx-zc(3,i)*cx
c         z(i,3)=zc(1,i)*cy+(zc(2,i)*cx+zc(3,i)*sx)*sy
         z(i,2)=-zc(2,i)*sx+zc(3,i)*cx
         z(i,3)=zc(1,i)*cy-(zc(2,i)*cx+zc(3,i)*sx)*sy
202      continue

         call put_ol_rec (31,opt,site,monu,xlon,ylat,salt,z
     &,                   sitel,cf,cc)

      endif
      stop
3101  format ('$$ END TABLE')
2301  format (2x,3(2x,2e12.4))

 99   print '(a)',' <Main-->>> EOF on unit ',iun,' errno=',ier
      stop
      end
