      REAL*8 FUNCTION DPHASE(Z)
C CMPX * Return Phase in degrees
      COMPLEX*16 Z,ZC
      REAL*8 RAD,DFATG
      DATA RAD/0.0174532925199/
      ZC=Z
      DPHASE=DMOD(DFATG(ZC)/RAD+360.D0,360.D0)
      RETURN
      END

      COMPLEX*16 FUNCTION DPOLAR(Z,ROUND)
C CMPX * Convert to polar, cut at ROUND
c
c skipped if ROUND is -540.0 and Z is real
c
      COMPLEX*16 Z
      REAL*8 X,Y,ROUND,DPHASE
      DPOLAR=Z
      Y=DIMAG(Z)
      IF (DABS((DABS(ROUND+540.d0))+DABS(Y)).LE.1.d-60) RETURN 
      X=ABS(Z)
      Y=DPHASE(Z) 
      Y=DMOD(Y+ROUND,360.D0)-ROUND
      DPOLAR=CMPLX(X,Y)
      RETURN
      END

      COMPLEX FUNCTION POLAR(Z,R)
C CMPX * Convert to polar, cut at R
      COMPLEX    Z
      COMPLEX*16 ZZ,ZV,DPOLAR
      REAL*8     ROUND
      ROUND=R
      ZZ=Z
      ZV=DPOLAR(ZZ,ROUND)
      POLAR=ZV
      RETURN
      END

      DOUBLE PRECISION FUNCTION DFATG (Z)
C CMPX * Returns ARG in rad
C
C ARC TAN OF (IM(Z) / RE(Z)) for complex*16 argument
C SFATG is the equivalent function, accepting complex*8 argument.
C The result is in radians.
C As an improvement to (D)ATAN2, +- PI/2 are returned if the real part
C of the argument is very small / zero.
C
      COMPLEX*16 Z
      REAL*8 D,IM,RE,DIM,DRE,PI
      DATA PI/3.14159265358979/
      IM=DIMAG(Z)
      RE=DREAL(Z)
      DIM=DABS(IM)
      DRE=DABS(RE)
      IF (DIM.LT.1.D-40.AND.DRE.LT.1.D-40) THEN
         D=0.D0
         GOTO 1
      ENDIF
      IF (DRE.LT.1.D-12*DIM) THEN
         IF (IM.GT.0.) THEN
            D=PI/2.D0
         ELSE
            D=-PI/2.D0
         ENDIF
         GOTO 1
      ENDIF
      IF (DIM.LT.1.D-12*DRE) THEN
         IF (RE.GT.0.D0) THEN
            D=0.
         ELSE
            D=PI
         ENDIF
         GOTO 1
      ENDIF
      D=DATAN2(IM,RE)
      IF (D.GT.PI) D=D-2.D0*PI
1     DFATG=D
      RETURN
      END

      FUNCTION SFATG (Z)
C CMPX * Returns ARG in rad
C
C ARC TAN OF (IM(Z) / RE(Z)) for complex*8 argument
C The result is in radians.
C As an improvement to ATAN2, +- PI/2 are returned if the real part
C of the argument is very small / zero.
C
      COMPLEX Z
      REAL*8 D,IM,RE,DIM,DRE,PI
      DATA PI/3.14159265358979/
      IM=AIMAG(Z)
      RE=REAL(Z)
      DIM=DABS(IM)
      DRE=DABS(RE)
      IF (DIM.LT.1.D-40.AND.DRE.LT.1.D-40) THEN
         D=0.D0
         GOTO 1
      ENDIF
      IF (DRE.LT.1.D-12*DIM) THEN
         IF (IM.GT.0.) THEN
            D=PI/2.D0
         ELSE
            D=-PI/2.D0
         ENDIF
         GOTO 1
      ENDIF
      IF (DIM.LT.1.D-12*DRE) THEN
         IF (RE.GT.0.D0) THEN
            D=0.
         ELSE
            D=PI
         ENDIF
         GOTO 1
      ENDIF
      D=DATAN2(IM,RE)
      IF (D.GT.PI) D=D-2.D0*PI
1     SFATG=D
      RETURN
      END

C:Provides  function sfatg F=phase.f
C:Provides  real*8 function dphase(z) F=phase.f
C:Provides  complex*16 function dpolar(z,round) F=phase.f
C:Provides  complex function polar(z,r) F=phase.f
C:Provides  double precision function dfatg F=phase.f
